#include "libcell.h"

void list_services (_comm_header *comm, _services *services, int debug)
{
_encaps_header *head;
_data_buffer *buff;
void  *temp;

dprint (DEBUG_TRACE,"--- List_services.c entered\n");
	
head = malloc (ENCAPS_Header_Length);
if (head ==NULL)
	{
	printf ("Could not allocate memory for list_services.\n");
	exit (-1);
	}
buff = malloc (DATA_Buffer_Length);
if (buff == NULL)
	{
	printf ("Could not allocate transmit buffer.\n");
	exit (-1);
	}
	

memset (buff,0, DATA_Buffer_Length );
memset (head,0, ENCAPS_Header_Length);
memset (services,0, sizeof(_services));

fill_header (comm, head, debug);

head->command = ENCAPS_List_Services;

memcpy (buff->data, head, ENCAPS_Header_Length);
buff->overall_len = ENCAPS_Header_Length;
senddata (buff, comm, debug);
readdata (buff, comm, debug);

temp = (void *)buff+ENCAPS_Header_Length+2; /* point to start of actual data */

memcpy (services, temp, sizeof(_services));

if (debug != DEBUG_NIL)
	{
	dprint (DEBUG_VALUES,"Item Type = %X\n",services->type);
	dprint (DEBUG_VALUES,"Descriptor Length = %d\n",services->length);
	dprint (DEBUG_VALUES,"Protocol Version = %d\n",services->version);
	dprint (DEBUG_VALUES,"Flags = %04X\n",services->flags);
	dprint (DEBUG_VALUES,"Service name = %s\n",services->name);
	}
free (buff);
free (head);
dprint (DEBUG_TRACE, "list_services.c exiting.\n");
return;
}


