#include "libcell.h"

void who (_comm_header *comm, _rack *rack, int debug)
{
_port *port;
_path *path;
int x;
dprint (DEBUG_TRACE,"who.c entered.\n");
port = malloc (sizeof(_port));
if (port == NULL)
	{
	printf ("Could not allocate memory for port structure - who.c\n");
	return;
	}
path = malloc (sizeof(_path));
if (path == NULL)
	{
	printf ("Could not allocate memory for path structure - who.c\n");
	free (port);
	return;
	}

if (rack == NULL)
	{
	printf ("Rack structure not allocated - who.c\n");
	free (port);
	free (path);
	return;
	}

if (rack->size == 0)
	{
	printf ("Rack size not set - who.c\n");
	free (port);
	free (path);
	return;
	}
	
for (x=0;x<rack->size;x++)
	{
	if (rack->identity[x] == NULL)
		{
		dprint (DEBUG_BUILD,"Allocating memory for identity object %d.\n",x);
		rack->identity[x] = malloc(sizeof(_identity));
		if (rack->identity[x] == NULL)
			{
			printf ("Could not allocate memory for identity object %d.\n",x);
			free (port);
			free (path);
			return;
			}
		}
	memset (rack->identity[x],0,sizeof(_identity));
	strcpy (rack->identity[x]->name,"--Empty Slot--");
	rack->identity[x]->namelen = strlen(rack->identity[x]->name);
	}	
path->device1 = -1;
path->device2 = -1;
path->device3 = -1;
path->device4 = -1;

dprint (DEBUG_VALUES,"Got slot number %d for ethernet card.\n",rack->slot);
get_device_data(comm, path, rack->identity[rack->slot],debug);
for (x=0;x<rack->size; x++)
	{
	if (rack->identity[x]->ID == 0)
		{
		dprint (DEBUG_VALUES,"Getting slot %d data...\n",x);
		path->device1 = 1;
		path->device2 = x;
		path->device3 = -1;
		path->device4 = -1;
		get_device_data (comm, path, rack->identity[x],debug);
		} 
	dprint (DEBUG_VALUES,"Slot %d - %s\n",x,rack->identity[x]->name);
	if (rack->identity[x]->type == 0x0e)
		{
		rack->cpulocation = x;
		dprint (DEBUG_VALUES,"CPU location %d memorized.\n",x);
		}
	if (debug != DEBUG_NIL)
		{
		dprint (DEBUG_VALUES,"ID = %02X   type = %02X - ",rack->identity[x]->ID, rack->identity[x]->type);
		if (rack->identity[x]->type < 32)
			{
			dprint (DEBUG_VALUES,"%s",PROFILE_Names[rack->identity[x]->type]);
			}
		else
			{
			dprint (DEBUG_VALUES,"Unknown type.");
			}
		dprint (DEBUG_VALUES,"\n");
		dprint (DEBUG_VALUES,"Product Code = %02X    Revision = %d.%02d\n",rack->identity[x]->product_code, rack->identity[x]->rev_hi, rack->identity[x]->rev_lo);
		dprint (DEBUG_VALUES,"Device Status = %04X    Device serial number - %08lX\n",rack->identity[x]->status, rack->identity[x]->serial);
		dprint (DEBUG_VALUES,"---------------------------\n");
		}
	}
free (port);
free (path);
dprint (DEBUG_TRACE,"who.c exited.\n");
return;
}
 
